#ifndef svfrun_h
#define svfrun_h

#include "svfparser.h"
#include <boost/shared_ptr.hpp>

namespace mlink {

    class Jtag_Impl;

    class SvfRun : public SvfParser {
    public:
        enum { CheckTdoException = true, NoCheckTdoException = false };
        SvfRun(boost::shared_ptr<Jtag_Impl> p, const std::string &fileName) : SvfParser(fileName), jtagImpl(p), _enableCheckException(true) { }
        void exec(bool enableCheckException = true);

    protected:
        void runShift(const JtagShift &jtagShift);
        void runStateChange(const JTAG_STATE &start, const JTAG_STATE &finish);

    private:
        boost::shared_ptr<Jtag_Impl> jtagImpl;
        bool _enableCheckException;
    };

};

#endif /* svfrun_h */
